package de.tub.mac13.teamb.util.visual;

import java.io.Serializable;

import de.tub.mac13.teamb.ontology.enums.TeamType;

//import massim.competition2012.GraphSimulationAgentState;
/**
 * This class represents a node in the graph that forms the map.
 */
public class GraphNode implements Serializable {

    private static final long serialVersionUID = -6260869513436004934L;
    public static final String NODE_NAME_PREFIX = "vertex";
    public int id;
    public int x;
    public int y;
    public int weight;
//	public Vector<GraphSimulationAgentState> agents;
    private TeamType dominatorTeam = null;
    public int gridX;
    public int gridY;

    public GraphNode(int nameNr, int weight, int gridX, int gridY, int x, int y) {

        this.id = nameNr;
        this.weight = weight;
        this.x = x;
        this.y = y;
        this.gridX = gridX;
        this.gridY = gridY;

    }

    /**
     * Two nodes are considered equal if they have the same name or the same raw
     * coordinates.
     */
    public boolean equals(Object obj) {

        if (obj == this) {
            return true;
        }

        if (obj == null) {
            return false;
        }

        if ((obj instanceof GraphNode) == false) {
            return false;
        }

        GraphNode n = (GraphNode) obj;

        // Use raw coordinates here to avoid repeating nodes in the generation algorithms.
        return ((this.id == (n.id)) || (this.x == n.x && this.y == n.y));

    }

    /**
     * @return the dominatorTeam
     */
    public TeamType getDominatorTeam() {
        return dominatorTeam;
    }

    /**
     * @param dominatorTeam the dominatorTeam to set
     */
    public void setDominatorTeam(TeamType dominatorTeam) {
        this.dominatorTeam = dominatorTeam;
    }

    @Override
    public String toString() {
        return String.format("Node(name=%s, x=%d, y=%d, gridX=%d, gridY=%d, weight=%d)",
                id, x, y, gridX, gridY, weight);
    }
}
